# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .chat_search_query import ChatSearchQuery
from .chat_search_result_connector import ChatSearchResultConnector

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class ChatSearchResult(pydantic.BaseModel):
    search_query: typing.Optional[ChatSearchQuery] = None
    connector: ChatSearchResultConnector = pydantic.Field()
    """
    The connector from which this result comes from.
    """

    document_ids: typing.List[str] = pydantic.Field()
    """
    Identifiers of documents found by this search query.
    """

    error_message: typing.Optional[str] = pydantic.Field(default=None)
    """
    An error message if the search failed.
    """

    continue_on_failure: typing.Optional[bool] = pydantic.Field(default=None)
    """
    Whether a chat request should continue or not if the request to this connector fails.
    """

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        extra = pydantic.Extra.allow
        json_encoders = {dt.datetime: serialize_datetime}
